;///////////////////////////////////////////////////////////////////////////////////
; Programa de prueba de envio de datos a 57600 bps por el puerto del usuario de C64
;///////////////////////////////////////////////////////////////////////////////////
; Ultima modificacion: 14-Feb-2016
;
; Versiones / correcciones
; ========================
; 14-02-2016	Primera version.
;========================================================================================

; Variables

	TXBYTE = $080E		; Variable usada para contener el byte a enviar

; Constantes

	SIDREG = $D400		; Comienzo de los registros del SID
	VICREG = $D000		; Comienzo de los registros del VIC II
	PLOT   = $FFF0		; Llamada a la rutina PLOT de la ROM Kernal
	CHROUT = $FFD2		; Llamada a la rutina CHROUT de la ROM Kernal
	STROUT = $AB1E		; Llamada a la rutina STROUT de la ROM BASIC
	COLORMEM = $D800	; Comienzo de la memoria de color de caracteres

	!to "sertest1.prg", cbm
;	!sl "labels.txt"

	*= $0801

;///////////////////////////////////////////////////////////////////////////////////
; PROGRAMA BASIC
;///////////////////////////////////////////////////////////////////////////////////

	!byte $0C, $08, $0A, $00, $9E, $20, $32, $30, $38, $35, $00	; 10 SYS 2085
	!byte $00, $00

;///////////////////////////////////////////////////////////////////////////////////
; INICIO (2083)
;///////////////////////////////////////////////////////////////////////////////////

	*= $0825

Start
	JMP	MainPrg		; Comienza el programa en MainPrg

;///////////////////////////////////////////////////////////////////////////////////
; SUBRUTINAS
;///////////////////////////////////////////////////////////////////////////////////

;///////////////////////////////////////////////////////////////////////////////////
; Subrutina SendByte, recibe en A el byte a enviar

SendByte
	STA	TXBYTE		; Guarda el contenido de A en TXBYTE
	LDA	$DD00		; Hace una copia de PRA (puerto A, CIA2)
	AND	#$FB		; Coloca un 0 en TX (bit de start)
	TAX			; y hace una copia en el registro X
SendStart
	STA	$DD00		; *** Comienzo del bit de start ***
;---------------------------------------------------------------------------------------
CalcB0
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ROR	TXBYTE		; 6 Obtiene en CARRY el bit 0 de TXBYTE
	BCS	Bit0Is1		; 2 Si CARRY=1 sigue en Bit0Is1
Bit0Is0
	JMP	SendB0		; 3 Si CARRY=0, sigue en SendB0
Bit0Is1				; 1 Para llegar aqui, se consumio 1 ciclo extra de reloj
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
SendB0
	STA	$DD00		; 4 Escribe el valor al puerto
				; *** Comienzo del bit 0 ***
;---------------------------------------------------------------------------------------
CalcB1
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ROR	TXBYTE		; 6 Obtiene en CARRY el bit 1 de TXBYTE
	BCS	Bit1Is1		; 2 Si CARRY=1 sigue en Bit1Is1
Bit1Is0
	JMP	SendB1		; 3 Si CARRY=0, sigue en SendB1
Bit1Is1				; 1 Para llegar aqui, se consumio 1 ciclo extra de reloj
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
SendB1
	STA	$DD00		; 4 Escribe el valor al puerto
				; *** Comienzo del bit 1 ***
;---------------------------------------------------------------------------------------
CalcB2
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ROR	TXBYTE		; 6 Obtiene en CARRY el bit 2 de TXBYTE
	BCS	Bit2Is1		; 2 Si CARRY=1 sigue en Bit2Is1
Bit2Is0
	JMP	SendB2		; 3 Si CARRY=0, sigue en SendB2
Bit2Is1				; 1 Para llegar aqui, se consumio 1 ciclo extra de reloj
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
SendB2
	STA	$DD00		; 4 Escribe el valor al puerto
				; *** Comienzo del bit 2 ***
;---------------------------------------------------------------------------------------
CalcB3
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ROR	TXBYTE		; 6 Obtiene en CARRY el bit 3 de TXBYTE
	BCS	Bit3Is1		; 2 Si CARRY=1 sigue en Bit3Is1
Bit3Is0
	JMP	SendB3		; 3 Si CARRY=0, sigue en SendB3
Bit3Is1				; 1 Para llegar aqui, se consumio 1 ciclo extra de reloj
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
SendB3
	STA	$DD00		; 4 Escribe el valor al puerto
				; *** Comienzo del bit 3 ***
;---------------------------------------------------------------------------------------
CalcB4
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ROR	TXBYTE		; 6 Obtiene en CARRY el bit 4 de TXBYTE
	BCS	Bit4Is1		; 2 Si CARRY=1 sigue en Bit4Is1
Bit4Is0
	JMP	SendB4		; 3 Si CARRY=0, sigue en SendB4
Bit4Is1				; 1 Para llegar aqui, se consumio 1 ciclo extra de reloj
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
SendB4
	STA	$DD00		; 4 Escribe el valor al puerto
				; *** Comienzo del bit 4 ***
;---------------------------------------------------------------------------------------
CalcB5
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ROR	TXBYTE		; 6 Obtiene en CARRY el bit 5 de TXBYTE
	BCS	Bit5Is1		; 2 Si CARRY=1 sigue en Bit5Is1
Bit5Is0
	JMP	SendB5		; 3 Si CARRY=0, sigue en SendB5
Bit5Is1				; 1 Para llegar aqui, se consumio 1 ciclo extra de reloj
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
SendB5
	STA	$DD00		; 4 Escribe el valor al puerto
				; *** Comienzo del bit 5 ***
;---------------------------------------------------------------------------------------
CalcB6
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ROR	TXBYTE		; 6 Obtiene en CARRY el bit 6 de TXBYTE
	BCS	Bit6Is1		; 2 Si CARRY=1 sigue en Bit6Is1
Bit6Is0
	JMP	SendB6		; 3 Si CARRY=0, sigue en SendB6
Bit6Is1				; 1 Para llegar aqui, se consumio 1 ciclo extra de reloj
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
SendB6
	STA	$DD00		; 4 Escribe el valor al puerto
				; *** Comienzo del bit 6 ***
;---------------------------------------------------------------------------------------
CalcB7
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ROR	TXBYTE		; 6 Obtiene en CARRY el bit 7 de TXBYTE
	BCS	Bit7Is1		; 2 Si CARRY=1 sigue en Bit7Is1
Bit7Is0
	JMP	SendB7		; 3 Si CARRY=0, sigue en SendB7
Bit7Is1				; 1 Para llegar aqui, se consumio 1 ciclo extra de reloj
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
SendB7
	STA	$DD00		; 4 Escribe el valor al puerto
				; *** Comienzo del bit 7 ***
;---------------------------------------------------------------------------------------
CalcStop
	TXA			; 2 Recupera en A el valor del puerto (almacenado en X)
	ORA	#$04		; 2 Al contenido de A se le coloca el bit 2 (TX) a 1
	NOP			; 2
	NOP			; 2
	NOP			; 2
	NOP			; 2
	NOP			; 2
SendStop
	STA	$DD00		; 4 *** Comienzo del bit de stop ***
;---------------------------------------------------------------------------------------
	NOP			; 2
	NOP			; 2
	NOP			; 2
	NOP			; 2
	NOP			; 2
	NOP			; 2
	RTS			; 6

;///////////////////////////////////////////////////////////////////////////////////
; Programa principal
;///////////////////////////////////////////////////////////////////////////////////

MainPrg
	LDA	#6		; Cambia el color de borde de pantalla a azul
	STA	$D020
	LDA	#14		; Cambia el color de fondo de pantalla a azul claro
	STA	$D021
	LDA	#$01		; Cambia el color de tinta a blanco
	STA	$0286
	LDA	#$93		; Borra la pantalla
	JSR	CHROUT
	LDA	#<Credits	; Muestra mensaje inicial
	LDY	#>Credits
	JSR	STROUT
	LDA	#6		; Coloca PB1 (RTS) y PB2 (DTR) como salida, y el resto como entrada en el puerto del usuario
	STA	$DD03
	LDA	$DD02		; Coloca PA2 (TXD) como salida en el puerto del usuario
	ORA	#4
	STA	$DD02
	LDA	$DD00		; Coloca un 1 en PA2 (TX: estado de reposo)
	ORA	#$04
	STA	$DD00
	SEI			; Deshabilita las interrupciones
	LDA	$DC0D		; Limpia los bits de interrupcion
	LDA	$D011		; Deshabilita el VIC II (apaga la pantalla)
	AND	#$10
	STA	$D011
Border
	LDA	$D011		; Espera a que el video llegue al borde inferior de la pantalla (bit 8 = 1, linea>255)
	AND	#%10000000
	BEQ	Border

	LDA	#0		; Envia el caracter NUL
	JSR	SendByte
	LDA	#"O"		; Envia el caracter "O"
	JSR	SendByte
	LDA	#"L"		; Envia el caracter "L"
	JSR	SendByte
	LDA	#"A"		; Envia el caracter "A"
	JSR	SendByte
	LDA	#"."		; Envia el caracter "."
	JSR	SendByte
	LDA	$D011		; Habilita de nuevo el VIC II
	ORA	#$10
	STA	$D011
	CLI			; Vuelve a habilitar las interrupciones
	RTS			; Retorna

;///////////////////////////////////////////////////////////////////////////////////
; Texto inicial
;///////////////////////////////////////////////////////////////////////////////////

Credits
	!byte $0D
	!text " ****** WWW.RETROCOMPUTACION.COM ******"
	!byte $0D, $0D
	!text "HOLA"
	!byte $0D, $0D
	!byte $00
